package	jp.co.sds_corp.tool.bean;

import java.io.PrintWriter;
import java.util.Vector;

public class FormatCreator extends TelegramCreator
{
	public FormatCreator( String file ) {
		super( file );
	}

	protected void printBean( PrintWriter out, Vector<BeanInfo> vec ) {
	}

	protected void printVar( PrintWriter out, Vector<BeanInfo> vec ) {
		printLayout( out, vec );
		printGetBytes( out, vec );
		printParseBuffer( out, vec );
		printFormat( out, vec );
	}

	protected void printLayout( PrintWriter out, Vector<BeanInfo> vec ) {
		out.println( "\tprivate void createLayout() {" );
		for ( int i = 0; i < vec.size(); i++ ) {
			TelegramInfo bean = (TelegramInfo )vec.get( i );
			out.println( "\t\taddLayout( \"" + bean.name + "\", "
					+ bean.len + " );" );
		}
		out.println( "\t}" );
		out.println( "" );
	}

	protected void printGetBytes( PrintWriter out, Vector<BeanInfo> vec ) {
		out.println( "\tpublic byte[] getBytes( Packet var ) {" );
		out.println( "\t\tPacket00 packet = (Packet00 )var;" );
		out.println( "\t\tByteArrayOutputStream bos = new ByteArrayOutputStream();" );
		out.println( "" );
		for ( int i = 0; i < vec.size(); i++ ) {
			TelegramInfo bean = (TelegramInfo )vec.get( i );
			if ( isControlChar( bean )) {
				out.println( "\t\tputField( bos, \"" + bean.name + "\", "
								+ "Packet." + bean.name + " );" );
			} else {
				out.println( "\t\tputField( bos, \"" + bean.name + "\", "
								+ "packet.get" + bean.func + "() );" );
			}
		}
		out.println( "" );
		out.println( "\t\tbyte[] ret = bos.toByteArray();" );
		out.println( "\t\tpacket.setBuffer( ret );" );
		out.println( "\t\treturn ret;" );
		out.println( "\t}" );
		out.println( "" );
	}

	protected void printParseBuffer( PrintWriter out, Vector<BeanInfo> vec ) {
		out.println( "\tpublic void parseBuffer( Packet var, byte[] buf ) throws Exception {" );
		out.println( "\t\tPacket00 packet = (Packet00 )var;" );
		out.println( "\t\tsuper.parseBuffer( buf );" );
		out.println( "" );
		for ( int i = 0; i < vec.size(); i++ ) {
			TelegramInfo bean = (TelegramInfo )vec.get( i );
			if ( isControlChar( bean )) {
			} else
			if ( bean.type.equals( "int" )) {
				out.println( "\t\tpacket.set" + bean.func + "( getLayout( \""
							+ bean.func + "\" ).getInt( buf ));" );
			} else
			if ( bean.type.equals( "BigDecimal" )) {
				out.println( "\t\tpacket.set" + bean.func + "( getLayout( \""
							+ bean.func + "\" ).getBigDecimal( buf ));" );
			} else
			if ( bean.type.equals( "Date" )) {
				out.println( "\t\tpacket.set" + bean.func + "( getLayout( \""
							+ bean.func + "\" ).getDate( buf ));" );
			} else
			if ( bean.type.equals( "byte" )) {
				out.println( "\t\tpacket.set" + bean.func + "( getLayout( \""
							+ bean.func + "\" ).getByte( buf ));" );
			} else {
				out.println( "\t\tpacket.set" + bean.func + "( getLayout( \""
							+ bean.func + "\" ).getString( buf ));" );
			}
		}
		out.println( "\t}" );
		out.println( "" );
	}

	protected void printFormat( PrintWriter out, Vector<BeanInfo> vec ) {
		out.println( "\tpublic String format( Packet var ) {" );
		out.println( "\t\tPacket00 packet = (Packet00 )var;" );
		out.println( "\t\tString ret = \"\";" );
		for ( int i = 0; i < vec.size(); i++ ) {
			TelegramInfo bean = (TelegramInfo )vec.get( i );
			if ( isControlChar( bean )) {
				continue;
			}
			if ( i < ( vec.size() - 1 )) {
				out.println( "\t\tret += "
								+ "packet.get" + bean.func + "() + \"\\t\";" );
			} else {
				out.println( "\t\tret += "
								+ "packet.get" + bean.func + "();" );
			}
		}
		out.println( "\t\treturn ret;" );
		out.println( "\t}" );
		out.println( "" );
	}

	public static void main( String[] args ) {
		for ( int i = 0; i < args.length; i++ ) {
			try {
				FormatCreator obj = new FormatCreator( args[i] );
				obj.convert();
			} catch ( Exception e ) {
				e.printStackTrace();
			}
		}
	}
}
